unit UTemplateLoader;
{*******************************************************************************
 This app is customized to load templates for the demo app one folder up.

 See the doc on TXLSDBTemplateStore for more info on how to use the loaded dbs.
*******************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  {$IFDEF ConditionalExpressions}{$if CompilerVersion >= 14} variants,{$IFEND}{$ENDIF} //Delphi 6 or above
  Dialogs, StdCtrls, XlsBaseTemplateStore, TemplateStore, DB, DBTables,
  ADODB;

type
  TFTemplateLoader = class(TForm)
    BtnLoad: TButton;
    ADOConnection1: TADOConnection;
    QInsertTemplate: TADOQuery;
    QInsertTemplateId: TAutoIncField;
    QInsertTemplateName: TWideStringField;
    QInsertTemplateData: TBlobField;
    QDeleteTemplates: TADOQuery;
    AutoIncField1: TAutoIncField;
    WideStringField1: TWideStringField;
    BlobField1: TBlobField;
    procedure BtnLoadClick(Sender: TObject);
  private
    procedure LoadTemplate(const id: integer; const Template: TXlsTemplate; const FileName: string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FTemplateLoader: TFTemplateLoader;

implementation

{$R *.dfm}

procedure TFTemplateLoader.BtnLoadClick(Sender: TObject);
var
  NewTemplate: TXlsTemplate;
begin
  QDeleteTemplates.ExecSQL; //Delete existing templates.
  NewTemplate:=TXlsTemplate.Create(nil);
  try
    //Add here all LoadTemplate calls you need
    LoadTemplate(1, NewTemplate, 'Charts.xls');
    LoadTemplate(2, NewTemplate, 'SimpleDemo.xls');

  finally
    FreeAndNil(NewTemplate);
  end; //finally
end;

procedure TFTemplateLoader.LoadTemplate(const id: integer; const Template: TXlsTemplate;
  const FileName: string);
var
  Ms: TMemoryStream;
begin
  Template.FileName:=FileName;
  QInsertTemplate.Parameters.ParamByName('id').Value:=id;
  QInsertTemplate.Parameters.ParamByName('name').Value:=ExtractFileName(FileName);
  Ms:=TMemoryStream.Create;
  try
    Template.Storages.WriteData(Ms);
    Ms.Position:=0;
    QInsertTemplate.Parameters.ParamByName('data').LoadFromStream(Ms, ftBlob);
  finally
    FreeAndNil(Ms);
  end; //finally
  QInsertTemplate.ExecSQL;
end;

end.
